#!/usr/bin/python

# Verify a system call in progess is logged by a new audit syscall rule

import tempfile
import subprocess
import time
import os
import signal
import re
import sys
import atexit

def cleanup():
	subprocess.check_call(['auditctl', '-D'], stdout=devnull)
	os.kill(auditd.pid, signal.SIGKILL)
	os.kill(mysleep.pid, signal.SIGKILL)

atexit.register(cleanup)

devnull = open('/dev/null', 'w')
subprocess.check_call(['auditctl', '-D'], stdout=devnull)

time.sleep(0.1)

logfile = tempfile.TemporaryFile()
auditd = subprocess.Popen(['auditd', '-f', '-s', 'enable'],
			  stdout=logfile, stderr=devnull)

time.sleep(1)

mysleep = subprocess.Popen(['./mysleep', '1'])

time.sleep(0.1)

subprocess.check_call(['auditctl', '-a', 'exit,always', '-F', 'arch=b64', '-S', 'nanosleep'])

time.sleep(2)

expected = [
	'type=SYSCALL.*comm="mysleep"',
]

for expect in expected:
	r = re.compile(expect)
	logfile.seek(0)
	found = False
	for line in logfile.readlines():
		if r.match(line):
			found = True

	if found == False:
		print 'Could not find audit entry containing %s' % expect
		print 'FAIL (expected)'
		sys.exit(1)
