/*
 * Abuse sched_yield so we can verify syscall arguments are logged
 * correctly in the audit log.
 */

#define _GNU_SOURCE
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/syscall.h>

int main(int argc, char *argv[])
{
	unsigned long a1, a2, a3, a4;

	if (argc != 5) {
		fprintf(stderr, "Usage sched_yield <arg1> <arg2> <arg3> <arg4>\n");
		exit(1);
	}

	a1 = strtoul(argv[1], NULL, 16);
	a2 = strtoul(argv[2], NULL, 16);
	a3 = strtoul(argv[3], NULL, 16);
	a4 = strtoul(argv[4], NULL, 16);

	syscall(SYS_sched_yield, a1, a2, a3, a4);

	return 0;
}
